// VC++.cpp : Defines the entry point for the console application.
//


#include <iostream.h>
#include <TCHAR.H>

#include"EquTranslator.h"


//User defined function
const TCalc __stdcall toRad(const TCalc& x)
{
	return 3.14/180;
}



int _tmain(int argc, _TCHAR* argv[])
{
	TCalc args[] = {2, 5.6, -11};   //arguments value
    TCalc res;
	TCalc twoPi=6.28;				//user defined const

	//Math expressions
    TCHAR *mathFunc = _T("F(x, y, z) = 3*x^2-y^2+exp(toRad(45))/twoPi");
    TCHAR *mathExp = _T("3*x^2-y^2+sqrt(toRad(85))/4.45+twoPi");
    TCHAR *varList = _T("x y z");

		
		try{

			AddFunction(_T("toRad"), toRad); 
			AddConst(_T("twoPi"), twoPi);

	        BuildEqu(mathFunc);
		    res = CalcFor(args);
			cout<<"Res="<<res<<endl; 

			RemoveFunction(_T("toRad"));
			Build(_T(""), _T("twoPi/2"));
			res = CalcFor(args);
	        cout<<"Res="<<res<<endl; 
			
			args[1]=-5;
			AddFunction(_T("toRad"), toRad);
		    res = EvaluateEqu(mathFunc, args);
			cout<<"Res="<<res<<endl; 

			RemoveConst(_T("twoPi"));
			res=Evaluate(varList, mathExp, args); //Error.  
			cout<<"Res="<<res<<endl; 

		} catch(EquException &e) {
			cout<<e.what().c_str();
		}

	return 0;
}

